﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace WebApplication9.Controllers
{
    public class StateController : Controller
    {
        // GET: State
        public ActionResult Index()
        {
            return View();
        }

        //1. Session management
        public ActionResult SessionTest()
        {
            if (Session["a"] != null)
            {
                ViewBag.Message = Session["a"];
            }
            else
            {
                ViewBag.Message = "Session['a'] is empty";
            }

            return View();
        }

        [HttpPost]
        public ActionResult SessionTest(string val)
        {
            if (!string.IsNullOrEmpty(val))
            {
                Session["a"] = val;

                return RedirectToAction("SessionTest");
            }

            return View();
        }


        //2. Application context management
        public ActionResult AppTest()
        {
            var appContext = HttpContext.Application;

            if (appContext["a"] != null)
            {
                ViewBag.Message = appContext["a"];
            }
            else
            {
                ViewBag.Message = "Application['a'] is empty";
            }

            return View();
        }

        [HttpPost]
        public ActionResult AppTest(string val)
        {
            var appContext = HttpContext.Application;

            if (!string.IsNullOrEmpty(val))
            {
                appContext["a"] = val;

                return RedirectToAction("AppTest");
            }

            return View();
        }


        //3. Cookie management
        public ActionResult CookieTest()
        {
            if (Request.Cookies["a"] != null)
            {
                ViewBag.Message = Request.Cookies["a"].Value;
            }
            else
            {
                ViewBag.Message = "Cookie['a'] is empty";
            }

            return View();
        }

        [HttpPost]
        public ActionResult CookieTest(string val)
        {
            HttpCookie cookie;

            if (!string.IsNullOrEmpty(val))
            {
                cookie = new HttpCookie("a");
                cookie.Value = val;
                cookie.Expires = DateTime.Now.AddSeconds(30);

                Response.Cookies.Add(cookie);

                return RedirectToAction("CookieTest");
            }

            return View();
        }

    }
}